Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -3874,5 +3657,5 @@
 
        nc_stat = NF90_CLOSE( id )
-       CALL handle_error( 'close', 537 )
+       CALL handle_error( 'close', 540 )
 #endif
     END SUBROUTINE close_input_file
@@ -3901,8 +3684,6 @@
            nc_stat = NF90_OPEN( filename, NF90_NOWRITE, id )
            collective_read = .FALSE.
-           write(9,*) 'open ',TRIM(filename),' as serial NetCDF file on every PE'
        ELSE
            collective_read = .TRUE.
-           write(9,*) 'open ',TRIM(filename),' using parallel NetCDF'
        END IF
 #else
@@ -3911,5 +3692,5 @@
 #endif
 
-       CALL handle_error( 'open_read_file', 536 )
+       CALL handle_error( 'open_read_file', 539 )
 
 #endif
@@ -3942,5 +3723,5 @@
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int32 global', 522 )
+          CALL handle_error( 'get_attribute_int32 global', 522, attribute_name )
 !
 !--    Read attributes referring to a single variable. Therefore, first inquire
@@ -3948,7 +3729,7 @@
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_int32', 522 )
+          CALL handle_error( 'get_attribute_int32', 522, attribute_name )
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int32', 522 )
+          CALL handle_error( 'get_attribute_int32', 522, attribute_name )
        ENDIF
 #endif
@@ -3981,5 +3762,5 @@
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int8 global', 523 )
+          CALL handle_error( 'get_attribute_int8 global', 523, attribute_name )
 !
 !--    Read attributes referring to a single variable. Therefore, first inquire
@@ -3987,7 +3768,7 @@
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_int8', 523 )
+          CALL handle_error( 'get_attribute_int8', 523, attribute_name )
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int8', 523 )
+          CALL handle_error( 'get_attribute_int8', 523, attribute_name )
        ENDIF
 #endif
@@ -4022,5 +3803,5 @@
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_real global', 524 )
+          CALL handle_error( 'get_attribute_real global', 524, attribute_name )
 !
 !-- Read attributes referring to a single variable. Therefore, first inquire
@@ -4028,7 +3809,7 @@
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_real', 524 )
+          CALL handle_error( 'get_attribute_real', 524, attribute_name )
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_real', 524 )
+          CALL handle_error( 'get_attribute_real', 524, attribute_name )
        ENDIF
 #endif
@@ -4063,5 +3844,5 @@
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_string global', 525 )
+          CALL handle_error( 'get_attribute_string global', 525, attribute_name )
 !
 !--    Read attributes referring to a single variable. Therefore, first inquire
@@ -4069,8 +3850,8 @@
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_string', 525 )
+          CALL handle_error( 'get_attribute_string', 525, attribute_name )
 
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_string',525 )
+          CALL handle_error( 'get_attribute_string',525, attribute_name )
 
        ENDIF
@@ -4102,9 +3883,9 @@
 !--    First, inquire dimension ID
        nc_stat = NF90_INQ_DIMID( id, TRIM( variable_name ), id_dim )
-       CALL handle_error( 'get_dimension_length', 526 )
+       CALL handle_error( 'get_dimension_length', 526, variable_name )
 !
 !--    Inquire dimension length
        nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, dum, LEN = dim_len )
-       CALL handle_error( 'get_dimension_length', 526 )
+       CALL handle_error( 'get_dimension_length', 526, variable_name )
 
 #endif
@@ -4133,9 +3914,9 @@
 !--    First, inquire variable ID
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-       CALL handle_error( 'get_variable_1d_int', 527 )
+       CALL handle_error( 'get_variable_1d_int', 527, variable_name )
 !
 !--    Inquire dimension length
        nc_stat = NF90_GET_VAR( id, id_var, var )
-       CALL handle_error( 'get_variable_1d_int', 527 )
+       CALL handle_error( 'get_variable_1d_int', 527, variable_name )
 
 #endif
@@ -4164,9 +3945,9 @@
 !--    First, inquire variable ID
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-       CALL handle_error( 'get_variable_1d_real', 527 )
+       CALL handle_error( 'get_variable_1d_real', 528, variable_name )
 !
 !--    Inquire dimension length
        nc_stat = NF90_GET_VAR( id, id_var, var )
-       CALL handle_error( 'get_variable_1d_real', 527 )
+       CALL handle_error( 'get_variable_1d_real', 528, variable_name )
 
 #endif
@@ -4208,5 +3989,5 @@
                                start = (/ 1,      t     /),                    &
                                count = (/ n_file, 1     /) )
-       CALL handle_error( 'get_variable_pr', 527 )
+       CALL handle_error( 'get_variable_pr', 529, variable_name )
 
 #endif
@@ -4220,5 +4001,5 @@
 !> i.e. each core reads its own domain in slices along x.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_2d_real( id, variable_name, i, var )
+    SUBROUTINE get_variable_2d_real( id, variable_name, var, is, ie, js, je )
 
        USE indices
@@ -4229,9 +4010,16 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  i               !< running index along x direction
+       INTEGER(iwp)                  ::  ie              !< start index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< end index for subdomain input along x direction
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-
-       REAL(wp), DIMENSION(nys:nyn), INTENT(INOUT) ::  var  !< variable to be read
+       INTEGER(iwp)                  ::  j               !< running index along y direction
+       INTEGER(iwp)                  ::  je              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< end index for subdomain input along y direction
+       
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  tmp   !< temporary variable to read data from file according
+                                                         !< to its reverse memory access
+       REAL(wp), DIMENSION(:,:), INTENT(INOUT) ::  var   !< variable to be read
 #if defined( __netcdf )
 !
@@ -4239,10 +4027,29 @@
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+!
+!--    Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je) )
+!
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var(nys:nyn),                       &
-                               start = (/ i+1, nys+1 /),                       &
-                               count = (/ 1, nyn - nys + 1 /) )
-
-       CALL handle_error( 'get_variable_2d_real', 528 )
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ is+1,      js+1 /),                  &
+                               count = (/ ie-is + 1, je-js+1 /) )   
+                               
+       CALL handle_error( 'get_variable_2d_real', 530, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je 
+             var(j-js+1,i-is+1) = tmp(i,j)
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )
+
 #endif
     END SUBROUTINE get_variable_2d_real
@@ -4254,5 +4061,5 @@
 !> i.e. each core reads its own domain in slices along x.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_2d_int32( id, variable_name, i, var )
+    SUBROUTINE get_variable_2d_int32( id, variable_name, var, is, ie, js, je )
 
        USE indices
@@ -4263,8 +4070,16 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  i               !< running index along x direction
+       INTEGER(iwp)                  ::  ie              !< start index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< end index for subdomain input along x direction
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(iwp), DIMENSION(nys:nyn), INTENT(INOUT) ::  var  !< variable to be read
+       INTEGER(iwp)                  ::  j               !< running index along y direction
+       INTEGER(iwp)                  ::  je              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< end index for subdomain input along y direction
+       
+       INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  tmp  !< temporary variable to read data from file according
+                                                            !< to its reverse memory access
+       INTEGER(iwp), DIMENSION(:,:), INTENT(INOUT) ::  var  !< variable to be read
 #if defined( __netcdf )
 !
@@ -4272,10 +4087,29 @@
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+!
+!--    Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je) )
+!
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var(nys:nyn),                       &
-                               start = (/ i+1, nys+1 /),                       &
-                               count = (/ 1, nyn - nys + 1 /) )
-
-       CALL handle_error( 'get_variable_2d_int32', 529 )
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ is+1,      js+1 /),                  &
+                               count = (/ ie-is + 1, je-js+1 /) )    
+                               
+       CALL handle_error( 'get_variable_2d_int32', 531, variable_name )                             
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je 
+             var(j-js+1,i-is+1) = tmp(i,j)
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )
+
 #endif
     END SUBROUTINE get_variable_2d_int32
@@ -4287,5 +4121,5 @@
 !> i.e. each core reads its own domain in slices along x.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_2d_int8( id, variable_name, i, var )
+    SUBROUTINE get_variable_2d_int8( id, variable_name, var, is, ie, js, je )
 
        USE indices
@@ -4296,8 +4130,16 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  i               !< running index along x direction
+       INTEGER(iwp)                  ::  ie              !< start index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< end index for subdomain input along x direction
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(KIND=1), DIMENSION(nys:nyn), INTENT(INOUT) ::  var  !< variable to be read
+       INTEGER(iwp)                  ::  j               !< running index along y direction
+       INTEGER(iwp)                  ::  je              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< end index for subdomain input along y direction
+       
+       INTEGER(KIND=1), DIMENSION(:,:), ALLOCATABLE   ::  tmp  !< temporary variable to read data from file according
+                                                               !< to its reverse memory access
+       INTEGER(KIND=1), DIMENSION(:,:), INTENT(INOUT) ::  var  !< variable to be read
 #if defined( __netcdf )
 !
@@ -4305,12 +4147,32 @@
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+!
+!--    Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je) )
+!
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var(nys:nyn),                       &
-                               start = (/ i+1, nys+1 /),                       &
-                               count = (/ 1, nyn - nys + 1 /) )
-
-       CALL handle_error( 'get_variable_2d_int8', 530 )
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ is+1,      js+1 /),                  &
+                               count = (/ ie-is + 1, je-js+1 /) )   
+                               
+       CALL handle_error( 'get_variable_2d_int8', 532, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je 
+             var(j-js+1,i-is+1) = tmp(i,j)
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )
+
 #endif
     END SUBROUTINE get_variable_2d_int8
+
 
 !------------------------------------------------------------------------------!
@@ -4319,5 +4181,6 @@
 !> Reads a 3D 8-bit INTEGER variable from file.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_3d_int8( id, variable_name, i, j, var )
+    SUBROUTINE get_variable_3d_int8( id, variable_name, var, is, ie, js, je,   &
+                                     ks, ke )
 
        USE indices
@@ -4328,30 +4191,53 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  ie              !< start index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< end index for subdomain input along x direction
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(iwp), INTENT(IN)      ::  j               !< index along y direction
-       INTEGER(iwp)                  ::  n_file          !< number of data-points along 3rd dimension
-
-       INTEGER(iwp), DIMENSION(1:3)  ::  id_dim
-
-       INTEGER( KIND = 1 ), DIMENSION(nzb:nzt+1), INTENT(INOUT) ::  var  !< variable to be read
+       INTEGER(iwp)                  ::  j               !< index along y direction
+       INTEGER(iwp)                  ::  je              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< end index for subdomain input along y direction
+       INTEGER(iwp)                  ::  k               !< index along any 3rd dimension
+       INTEGER(iwp)                  ::  ke              !< start index of 3rd dimension
+       INTEGER(iwp)                  ::  ks              !< end index of 3rd dimension
+       
+       INTEGER(KIND=1), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp  !< temporary variable to read data from file according 
+                                                                 !< to its reverse memory access
+
+       INTEGER(KIND=1), DIMENSION(:,:,:), INTENT(INOUT) ::  var  !< variable to be read
 #if defined( __netcdf )
 
 !
 !--    Inquire variable id
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-!
-!--    Get length of first dimension, required for the count parameter.
-!--    Therefore, first inquired dimension ids
-       nc_stat = NF90_INQUIRE_VARIABLE( id, id_var, DIMIDS = id_dim )
-       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim(3), LEN = n_file )
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )   
+!
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+!
+!--    Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je,ks:ke) )
 !
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var,                  &
-                               start = (/ i+1, j+1, 1 /),                      &
-                               count = (/ 1, 1, n_file /) )
-
-       CALL handle_error( 'get_variable_3d_int8', 531 )
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ is+1,    js+1,    ks+1 /),           &
+                               count = (/ ie-is+1, je-js+1, ke-ks+1 /) )                              
+
+       CALL handle_error( 'get_variable_3d_int8', 533, variable_name )                               
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je
+             DO  k = ks, ke
+                var(k-ks+1,j-js+1,i-is+1) = tmp(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )
+
 #endif
     END SUBROUTINE get_variable_3d_int8
@@ -4363,5 +4249,6 @@
 !> Reads a 3D float variable from file.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_3d_real( id, variable_name, i, j, var )
+    SUBROUTINE get_variable_3d_real( id, variable_name, var, is, ie, js, je,   &
+                                     ks, ke )
 
        USE indices
@@ -4372,30 +4259,52 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  ie              !< start index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< end index for subdomain input along x direction
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(iwp), INTENT(IN)      ::  j               !< index along y direction
-       INTEGER(iwp)                  ::  n3              !< number of data-points along 3rd dimension
-
-       INTEGER(iwp), DIMENSION(3)    ::  id_dim
-
-       REAL(wp), DIMENSION(:), INTENT(INOUT) ::  var     !< variable to be read
+       INTEGER(iwp)                  ::  j               !< index along y direction
+       INTEGER(iwp)                  ::  je              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< end index for subdomain input along y direction
+       INTEGER(iwp)                  ::  k               !< index along any 3rd dimension
+       INTEGER(iwp)                  ::  ke              !< start index of 3rd dimension
+       INTEGER(iwp)                  ::  ks              !< end index of 3rd dimension
+       
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp !< temporary variable to read data from file according 
+                                                         !< to its reverse memory access
+
+       REAL(wp), DIMENSION(:,:,:), INTENT(INOUT) ::  var  !< variable to be read
 #if defined( __netcdf )
 
 !
 !--    Inquire variable id
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-!
-!--    Get length of first dimension, required for the count parameter.
-!--    Therefore, first inquired dimension ids
-       nc_stat = NF90_INQUIRE_VARIABLE( id, id_var, DIMIDS = id_dim )
-       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim(3), LEN = n3 )
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )  
+!
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF
+!
+!--    Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je,ks:ke) )
 !
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var,                                &
-                               start = (/ i+1, j+1, 1 /),                      &
-                               count = (/ 1, 1, n3 /) )
-
-       CALL handle_error( 'get_variable_3d_real', 532 )
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ is+1,    js+1,    ks+1 /),           &
+                               count = (/ ie-is+1, je-js+1, ke-ks+1 /) )   
+                               
+       CALL handle_error( 'get_variable_3d_real', 534, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je
+             DO  k = ks, ke
+                var(k-ks+1,j-js+1,i-is+1) = tmp(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )
 
 #endif
@@ -4407,5 +4316,85 @@
 !> Reads a 3D float array from file.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_3d_real_v( id, variable_name, is, ie, js, je, var )
+!     SUBROUTINE get_variable_3d_real_v( id, variable_name, is, ie, js, je, var )
+! 
+!        USE indices
+!        USE pegrid
+! 
+!        IMPLICIT NONE
+! 
+!        CHARACTER(LEN=*)              ::  variable_name   !< variable name
+! 
+!        INTEGER(iwp), INTENT(IN)      ::  is,ie           !< index range along x direction
+!        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
+!        INTEGER(iwp)                  ::  id_var          !< variable id
+!        INTEGER(iwp), INTENT(IN)      ::  js,je           !< index range along y direction
+!        INTEGER(iwp)                  ::  n3              !< number of data-points along 3rd dimension
+! 
+!        INTEGER(iwp)                  ::  i,j,k
+!        INTEGER(iwp), DIMENSION(3)    ::  id_dim
+! 
+!        REAL(wp), DIMENSION(:,:,:), INTENT(INOUT) ::  var         !< variable to be read
+! #if defined( __netcdf )
+! !
+! !--    Inside the ...static NetCDF files, the array is stored as float.
+! !--    Therefore single precision is sufficiant for the temporary array
+! 
+!        REAL(sp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_var     !< temporary array to read NetCDF data in i,j,k direction
+! 
+! !kk    Please check, if it is time consuming to do the inquire every time
+! !
+! !--    Inquire variable id
+!        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+! !
+! !--    Get length of third dimension, required for the count parameter.
+! !--    Therefore, first inquired dimension ids
+!        nc_stat = NF90_INQUIRE_VARIABLE( id, id_var, DIMIDS = id_dim )
+!        nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim(3), LEN = n3 )
+! 
+! !
+! !--    Check for collective read-operation and set respective NetCDF flags if
+! !--    required. 
+!        IF ( collective_read )  THEN
+!           nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+!        ENDIF
+! 
+! !
+! !--    Allocate temporary array ro read NetCDF data in i,j,k direction
+! 
+!        ALLOCATE(tmp_var(is:ie,js:je,n3))
+! !
+! !--    Get variable
+! !--    Read complete local 3-D array in oone call
+! 
+!        nc_stat = NF90_GET_VAR( id, id_var, tmp_var,                            &
+!                                start = (/ is+1, js+1, 1 /),                    &
+!                                count = (/ ie-is+1, je-js+1, n3 /) )
+! 
+!        CALL handle_error( 'get_variable_3d_real', 532 )
+! 
+! !
+! !--    Resort data in k,j,i direction
+! 
+!        DO i=is,ie
+!           DO j=js,je
+!              DO K=1,n3
+!                 var (k,j-js+1,i-is+1) = tmp_var(i,j,k)
+!              END DO
+!           END DO
+!        END DO
+! 
+!        DEALLOCATE(tmp_var)
+! 
+! #endif
+!     END SUBROUTINE get_variable_3d_real_v
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a 4D float variable from file. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_4d_real( id, variable_name, var, is, ie, js, je,   &
+                                     k1s, k1e, k2s, k2e )
 
        USE indices
@@ -4416,64 +4405,60 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  is,ie           !< index range along x direction
+       INTEGER(iwp)                  ::  i               !< index along x direction
+       INTEGER(iwp)                  ::  ie              !< start index for subdomain input along x direction
+       INTEGER(iwp)                  ::  is              !< end index for subdomain input along x direction
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(iwp), INTENT(IN)      ::  js,je           !< index range along y direction
-       INTEGER(iwp)                  ::  n3              !< number of data-points along 3rd dimension
-
-       INTEGER(iwp)                  ::  i,j,k
-       INTEGER(iwp), DIMENSION(3)    ::  id_dim
-
-       REAL(wp), DIMENSION(:,:,:), INTENT(INOUT) ::  var         !< variable to be read
+       INTEGER(iwp)                  ::  j               !< index along y direction
+       INTEGER(iwp)                  ::  je              !< start index for subdomain input along y direction
+       INTEGER(iwp)                  ::  js              !< end index for subdomain input along y direction
+       INTEGER(iwp)                  ::  k1              !< index along 3rd direction
+       INTEGER(iwp)                  ::  k1e             !< start index for 3rd dimension
+       INTEGER(iwp)                  ::  k1s             !< end index for 3rd dimension
+       INTEGER(iwp)                  ::  k2              !< index along 4th direction
+       INTEGER(iwp)                  ::  k2e             !< start index for 4th dimension
+       INTEGER(iwp)                  ::  k2s             !< end index for 4th dimension
+
+       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE   ::  tmp  !< temporary variable to read data from file according
+                                                            !< to its reverse memory access
+       REAL(wp), DIMENSION(:,:,:,:), INTENT(INOUT) ::  var  !< variable to be read
 #if defined( __netcdf )
-!
-!--    Inside the ...static NetCDF files, the array is stored as float.
-!--    Therefore single precision is sufficiant for the temporary array
-
-       REAL(sp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp_var     !< temporary array to read NetCDF data in i,j,k direction
-
-!kk    Please check, if it is time consuming to do the inquire every time
+
 !
 !--    Inquire variable id
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
-!--    Get length of first dimension, required for the count parameter.
-!--    Therefore, first inquired dimension ids
-       nc_stat = NF90_INQUIRE_VARIABLE( id, id_var, DIMIDS = id_dim )
-       nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim(3), LEN = n3 )
-
-       IF(collective_read)  THEN
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
           nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
        ENDIF
-
-!
-!--    Allocate temporary array ro read NetCDF data in i,j,k direction
-
-       ALLOCATE(tmp_var(is:ie,js:je,n3))
+!
+!--    Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e) )
 !
 !--    Get variable
-!--    Read complete local 3-D array in oone call
-
-       nc_stat = NF90_GET_VAR( id, id_var, tmp_var,                              &
-                               start = (/ is+1, js+1, 1 /),                      &
-                               count = (/ ie-is+1, je-js+1, n3 /) )
-
-       CALL handle_error( 'get_variable_3d_real', 532 )
-
-!
-!--    Resort data in k,j,i direction
-
-       DO i=is,ie
-          DO j=js,je
-             DO K=1,n3
-                var (k,j-js+1,i-is+1) = tmp_var(i,j,k)
-             END DO
-          END DO
-       END DO
-
-       DEALLOCATE(tmp_var)
-
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ is+1,    js+1,   k1s+1, k2s+1 /),    &
+                               count = (/ ie-is+1, je-js+1,                    &
+                                          k1e-k1s+1, k2e-k2s+1 /) )
+
+       CALL handle_error( 'get_variable_4d_real', 535, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je
+             DO  k1 = k1s, k1e
+                DO  k2 = k2s, k2e
+                   var(k2-k2s+1,k1-k1s+1,j-js+1,i-is+1) = tmp(i,j,k1,k2)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )
 #endif
-    END SUBROUTINE get_variable_3d_real_v
+    END SUBROUTINE get_variable_4d_real
+
 
 
